#!/bin/bash

# if image doesn't exist, build it.

BUILD=bbs-build:0.1

if [ -z $(docker images -q $BUILD) ]; then
echo "Creating bbs-build image..."

DOCKER_BUILDKIT=1 docker build -t $BUILD - << DOCKERFILE
FROM debian:stretch-slim 
# Install utilities essential to building BBS DOORS
RUN apt-get update && apt-get -y install wget build-essential unzip git cmake ninja-build libsqlite3-dev
DOCKERFILE

fi

echo "Cleaning dbuild directory"
rm -rf dbuild
mkdir dbuild

echo "Building using docker bbs-build image..."
USERID=`id -u`
GROUPID=`id -g`
# docker run -it --rm -u $USERID:$GROUPID -v $(pwd):/build -w /build/dbuild $BUILD bash -c "cmake -G Ninja -DCMAKE_BUILD_TYPE=Debug ..; ninja"
docker run -it --rm -u $USERID:$GROUPID -v $(pwd):/build -w /build/dbuild $BUILD bash -c "cmake -G Ninja -DCMAKE_BUILD_TYPE=Release ..; ninja"

# docker run -it --rm -u 1000:1000 -v $(pwd):/build -w /build/dbuild bbs-build bash -c "cmake -DCMAKE_BUILD_TYPE=Release ..; make"
# -DCMAKE_BUILD_TYPE=Release

echo "Build results:"
ls -la dbuild

# echo "to build:"
# echo "rm -rf dbuild; mkdir dbuild; cd dbuild; cmake ..; make"
# docker run -it --rm -u 1000:1000 -v $(pwd):/build -w /build bbs-build

