#ifndef USER_H
#define USER_H

#include <string>

class User {
  private:
    int uid, experience, gun, fuel, metal, armor, shield, hitpoints, armorpoints, shieldpoints, shieldsup, laston;
    bool dirt;
    std::string nick, real;
  public:
    // Constructors
    User(void);
    User(std::string, std::string);
    User(int uuid, std::string name, std::string realname, int exp, int lo, int a, int ap, int s, int sp, int su, int hp, int g, int m, int f);
    // Initalizer
    void init(void);
    // Methods
    bool dirty(void);
    int calcArmor(void);
    int calcShield(void);
    int calcGun(void);
    int calcHP(void);
    int calcAP(void);
    int calcSP(void);
    void regen(void);
    void repair(bool);
    int takeDamage(int);
    // Sets and Gets
    void set_dirt(bool);
    bool get_dirt(void);
    void set_uid(int);
    int get_uid(void);
    void set_experience(int);
    int get_experience(void);
    void set_gun(int);
    int get_gun(void);
    void set_armor(int);
    int get_armor(void);
    void set_shield(int);
    int get_shield(void);
    void set_armorpoints(int);
    int get_armorpoints(void);
    void set_shieldpoints(int);
    int get_shieldpoints(void);
    void set_shieldsup(int);
    int get_shieldsup(void);
    void set_hitpoints(int);
    int get_hitpoints(void);
    void set_laston(int);
    int get_laston(void);
    void set_metal(int);
    int get_metal(void);
    void set_fuel(int);
    int get_fuel(void);
    void set_nick(std::string);
    std::string get_nick(void);
    void set_real(std::string);
    std::string get_real(void);
    // Adds and Removes
    void addEXP(int);
    void rmEXP(int);
    void addMetal(int);
    void rmMetal(int);
    void addFuel(int);
    void rmFuel(int);
    void rmLaston(int);
    void addHP(int);
    void addGun(int);
    void addArmor(int);
    void addShield(int);
    void rmSU(int);
};

#endif